#include <glib.h>
#include "enums.h"

static gboolean registered = FALSE;

static const GEnumValue pipeline_state_values[] =
{{PIPELINE_STATE_RUNNING, "PIPELINE_STATE_RUNNING", "running"},
 {PIPELINE_STATE_STOPPED, "PIPELINE_STATE_STOPPED", "stopped"},
 {PIPELINE_STATE_UNKNOWN, "PIPELINE_STATE_UNKNOWN", "unknown"},
 {PIPELINE_STATE_DEFUNCT, "PIPELINE_STATE_DEFUNCT", "defunct"},
 {0, NULL, NULL}
};

static GType pipeline_state_enum_type;

void
enums_register(void)
{
    if (!registered) {
        g_type_init();
        pipeline_state_enum_type =
            g_enum_register_static("pipeline_state_t", pipeline_state_values);
        registered = TRUE;
    }
}

GType
pipeline_state_enum_get_type(void)
{
    if (!registered) {
        enums_register();
    }
    return pipeline_state_enum_type;
}
