#ifndef WCBE_MC_H_
#define WCBE_MC_H_
#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <wcbe.h>
#include <wcbe_app.h>
#include <wcbe_private.h>

G_BEGIN_DECLS

typedef void (*request_cb_fn_t)(pipeline_t *, wcbe_msg_t **, gsize *,
                                GstStructure *structure);
typedef request_cb_fn_t (*request_fn_t)(pipeline_t *, wcbe_msg_t **, gsize *);

extern request_cb_fn_t wcbe_mc_config_create_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_config_activate_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_config_destroy_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_config_list_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_src_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_src_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_live_ts_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_live_ts_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_framedump_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_framedump_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_flow_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_flow_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_rate_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_rate_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_name_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_quit_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_pipeline_list_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_element_list_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_property_list_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_property_command(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_property_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_pad_list_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_pad_caps_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);
extern request_cb_fn_t wcbe_mc_pad_peer_query(
    pipeline_t *pipeline, wcbe_msg_t **msg, gsize *msgsize);

G_END_DECLS

#endif
