#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <gst/gst.h>
#include <wcbe_lagset_src.h>

struct _elements_entry {
    const gchar *name;
    guint rank;
    GType (*type) (void);
};

static struct _elements_entry _elements[] = {
    {"wcbe_lagset_src", GST_RANK_NONE, wcbe_lagset_src_get_type},
    {NULL, 0},
};

static gboolean
plugin_init (GstPlugin *plugin)
{
    struct _elements_entry *element = _elements;

    while (element->name != NULL) {
        if (!gst_element_register(plugin, element->name, element->rank,
                                  element->type())) {
            return FALSE;
        }
        element++;
    }
    return TRUE;
}

GST_PLUGIN_DEFINE (
    GST_VERSION_MAJOR,
    GST_VERSION_MINOR,
    "wcbecoreelements",
    "WIDAR backend lag processing stage core elements",
    plugin_init,
    VERSION,
    "GPL",
    PACKAGE,
    "http://www.aoc.nrao.edu/evla"
    );
