#ifndef WCBE_FRAMEDUMP_H__
#define WCBE_FRAMEDUMP_H__

#include <gst/gst.h>
#include <gst/base/gstbasetransform.h>
#include <wcbe_lag_frame.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_FRAMEDUMP (wcbe_framedump_get_type())
#define WCBE_FRAMEDUMP(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_FRAMEDUMP,WcbeFramedump))
#define WCBE_FRAMEDUMP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_FRAMEDUMP,WcbeFramedumpClass))
#define WCBE_IS_FRAMEDUMP(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_FRAMEDUMP))
#define WCBE_IS_FRAMEDUMP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_FRAMEDUMP))

typedef struct _WcbeFramedump      WcbeFramedump;
typedef struct _WcbeFramedumpClass WcbeFramedumpClass;

typedef enum {
    WCBE_FRAMEDUMP_ASCII,
    WCBE_FRAMEDUMP_BINARY
} WcbeFramedumpFormat;

#define WCBE_TYPE_FRAMEDUMP_FORMAT (wcbe_framedump_format_get_type())

GType wcbe_framedump_format_get_type(void);

struct _WcbeFramedump {
    GstBaseTransform element;
    gboolean do_output;
    WcbeFramedumpFormat format;
    off64_t (*output_fn)(const lf_data_frame_word_t *df);
    void (*close_fn)(void);
    off64_t max_file_size;
};

struct _WcbeFramedumpClass {
  GstBaseTransformClass parent_class;
};

GType wcbe_framedump_get_type(void);

G_END_DECLS

#endif /* WCBE_FRAMEDUMP_H__ */
