#ifndef WCBE_SORT_H__
#define WCBE_SORT_H__

#include <gst/gst.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_SORT \
  (wcbe_sort_get_type())
#define WCBE_SORT(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_SORT,WcbeSort))
#define WCBE_SORT_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_SORT,WcbeSortClass))
#define WCBE_IS_SORT(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_SORT))
#define WCBE_IS_SORT_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBBE_TYPE_SORT))

typedef struct _WcbeSort      WcbeSort;
typedef struct _WcbeSortClass WcbeSortClass;

typedef struct wcbe_sort_cfg {
    gchar *name;
    GSList *queues;
    GHashTable *destinations;
    gboolean destroy;
    WcbeSort *sort;
} wcbe_sort_cfg_t;

struct _WcbeSort {
    GstElement element;

    GstPad *sinkpad, *srcpad;
    GThread *timeout_thread;
    GMutex *config_mutex;
    GCond *config_cond;
    gboolean new_config;
    wcbe_sort_cfg_t *config;
    GHashTable *configurations;
    GstBuffer *dummy_buffer;
};

struct _WcbeSortClass {
    GstElementClass parent_class;
};

GType wcbe_sort_get_type(void);

extern gboolean wcbe_sort_create_config(WcbeSort *sort,
                                        const gchar *config,
                                        const gchar *name);
extern gboolean wcbe_sort_activate_config(WcbeSort *sort,
                                          const gchar *cfg_name);
extern void wcbe_sort_destroy_config(WcbeSort *sort,
                                     const gchar *cfg_name);

G_END_DECLS

#endif /* WCBE_SORT_H__ */
