#ifndef WCBE_SRC_H__
#define WCBE_SRC_H__

#include <gst/gst.h>
#include <gst/base/gstpushsrc.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_SRC (wcbe_src_get_type())
#define WCBE_SRC(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_SRC,WcbeSrc))
#define WCBE_SRC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_SRC,WcbeSrcClass))
#define WCBE_IS_SRC(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_SRC))
#define WCBE_IS_SRC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_SRC))

typedef struct _WcbeSrc      WcbeSrc;
typedef struct _WcbeSrcClass WcbeSrcClass;

struct _WcbeSrc {
    GstPushSrc element;
    gchar *uri;
    guint fps;
    gboolean live_timestamps;
    gint control_sock[2];
    gulong widar_max_framesize;
    GIOChannel *channel;
    guint64 num_frames;
    GstCaps *caps;
};

struct _WcbeSrcClass {
  GstPushSrcClass parent_class;
};

GType wcbe_src_get_type(void);

G_END_DECLS

#endif /* WCBE_SRC_H__ */
